//Конкатенация индексов
function [indexMatrix]=ConcatIndexes(indexMatrix1,indexMatrix2,grid)
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 1 then
        error('The function ConcatIndexes takes 1, 2 or 3 arguments');
    end
    select nArg
    case 1 then
        isList = %t;
        if type(indexMatrix1) == 15 then
            indexMatrixes = indexMatrix1;
        else
            error('The argument indexMatrixes of function ConcatIndexes must be list');
        end
        grid = %t;//По умолчанию делаем сетку
    case 2 then
        isList = (type(indexMatrix1) == 15) &&..
                 (type(indexMatrix2) == 4);
        if isList then
            indexMatrixes = indexMatrix1;
            grid = indexMatrix2;
        else
            grid = %t;//По умолчанию делаем сетку
        end
    else
        isList = %f;
    end
    
    //Делаем конкатенацию
    if isList then
        //Проверяем корректность аргументов
        if type(grid) ~= 4 then
            error('The argument grid of function ConcatIndexes must be boolean matrix');
        end
        indexMatrix = indexMatrixes(1);//Первый элемент матрицы в списке
        nIndexMatrixes = size(indexMatrixes);
        if nIndexMatrixes < 2 then
            //Конкатеновать уже нечего, выходим из программы
            return;
        end
        grid = matrix(grid,1,-1);
        nGrid = size(grid,'*');
        if nGrid < nIndexMatrixes - 1 then
            grid = repmat(grid,[1,nIndexMatrixes - nGrid]);
        else
            grid = grid(1:(nIndexMatrixes - 1));
        end
        
        //Конкатенуем
        for ind=2:nIndexMatrixes
            //Проверяем тип данных аргументов
            if (~isempty(indexMatrix)) &&..
               (~isempty(indexMatrixes(ind))) &&..
               (type(indexMatrix) ~= type(indexMatrixes(ind)))
                error('The types of arguments indexMatrixes of function ConcatIndexes must be equality');
            end
            nIndexMatrix = size(indexMatrix)(1);
            nCurIndexmatrix = size(indexMatrixes(ind))(1);
            if (~grid(ind - 1)) && (nIndexMatrix ~= nCurIndexmatrix) &&..
               (nIndexMatrix > 1) && (nCurIndexmatrix > 1) then
                error('If grid is false then number of combination indexes of arguments indexMatrixes of function ConcatIndexes must be equality');
            end
            
            //Делаем попарную конкатенацию
            indexMatrix = ConcatIndexes(indexMatrix,indexMatrixes(ind),grid(ind - 1));
        end
    else
        //Проверяем корректность аргументов
        isEmIndexMatrix1 = isempty(indexMatrix1);
        isEmIndexMatrix2 = isempty(indexMatrix2);
        if (type(indexMatrix1) ~= type(indexMatrix2)) &&..
           (~isEmIndexMatrix1) && (~isEmIndexMatrix2) then
            error('The function''s ConcatIndexes arguments'' indexMatrix1 and indexMatrix2 types must be equality');
        end
        if (type(grid) ~= 4) || (size(grid,'*') > 1) then
            error('The argument grid of function ConcatIndexes must be boolean scalar');
        end
        if isEmIndexMatrix1 then
            indexMatrix = indexMatrix2;
            return;
        end
        if isEmIndexMatrix2 then
            indexMatrix = indexMatrix1;
            return;
        end
        nIndex1 = size(indexMatrix1)(1);//Число индексов аргументов 1
        nIndex2 = size(indexMatrix2)(1);//Число индексов аргументов 2
        if (~grid) && (nIndex1 ~= nIndex2) && (nIndex1 > 1) && (nIndex2 > 1) then
            error('If grid is false then the number of concatenate indexes'' combinations must be equality');
        end
        
        //Конкатенуем индексы
        if grid || (nIndex1 == 1) || (nIndex2 == 1) then
            //Формируем индексы строк
            strIndex1 = 1:nIndex1;//Индексы строк индексов 1
            strIndex2 = 1:nIndex2;//Индексы строк индексов 2
            [strIndex2,strIndex1] = ndgrid(strIndex2,strIndex1);
            strIndex1 = matrix(strIndex1,1,-1);//Индексы строк индексов 1
            strIndex2 = matrix(strIndex2,1,-1);//Индексы строк индексов 2
            
            //Размножаем комбинации индексов
            indexMatrix1 = indexMatrix1(strIndex1,:);//Индексы 1
            indexMatrix2 = indexMatrix2(strIndex2,:);//Индексы 2
        end
        indexMatrix = [indexMatrix1,indexMatrix2];//Конкатенуем
    end
endfunction
