//Конкатенация индексов
function [fileIndexNames,..
          indexMatrix]=FileNamesIndexes(beginPartName,..//Начальная часть имени файла
                                        endPartName,..//Конечная часть имени файла
                                        indexSepName,..//Ращзделитель индексов
                                        extFile,..//Расширение файла
                                        indexMatrix1,..//Матрица индексов 1 (или список матриц индексов)
                                        indexMatrix2,..//Матрица индексов 2
                                        grid..//Необходимость сеточного размножения индексов
                                        )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 5 then
        error('The function FileNamesIndexes takes 5, 6 or 7 arguments');
    end
    
    //Проверяем корректность аргументов
    if (type(beginPartName) ~= 10) || (size(beginPartName,'*') > 1) then
        error('The argument beginPartName of function FileNamesIndexes must be scalar string');
    end
    if (type(endPartName) ~= 10) || (size(endPartName,'*') > 1) then
        error('The argument endPartName of function FileNamesIndexes must be scalar string');
    end
    if (type(indexSepName) ~= 10) || (size(indexSepName,'*') > 1) then
        error('The argument indexSepName of function FileNamesIndexes must be scalar string');
    end
    if (type(extFile) ~= 10) || (size(extFile,'*') > 1) then
        error('The argument extFile of function FileNamesIndexes must be scalar string');
    end
    
    //Проверяем аргументы в зависимости от числа аргументов и делаем конкатенацию
    select nArg
    case 5 then
        [fileIndexNames,..
         indexMatrix] = NamesIndexes(beginPartName,endPartName,..
                                     indexSepName,indexMatrix1);//Формируем локальное имя файла без расширения
    case 6 then
        if (type(indexMatrix1) == 15) && (type(indexMatrix2) ~= 4) then
            error("The argument grid of function FileNamesIndexes must be boolean");
        end
        [fileIndexNames,..
         indexMatrix] = NamesIndexes(beginPartName,endPartName,..
                                     indexSepName,indexMatrix1,..
                                     indexMatrix2);
    else
        if type(grid) ~= 4 then
            error("The argument grid of function FileNamesIndexes must be boolean");
        end
        [fileIndexNames,..
         indexMatrix] = NamesIndexes(beginPartName,endPartName,..
                                     indexSepName,indexMatrix1,..
                                     indexMatrix2,grid);
    end
    
    //Конкатенуем с расширением
    if part(extFile,1) ~= '.' then
        extFile = '.' + extFile;//Добавляем к расширению точку при необходимости
    end
    fileIndexNames = fileIndexNames + extFile;//Добавляем расширение
endfunction
