//Конкатенация индексов
function [indexNames,..
          indexMatrix]=NamesIndexes(beginPartName,..//Начальная часть имени
                                    endPartName,..//Конечная часть имени
                                    indexSepName,..//Ращзделитель индексов
                                    indexMatrix1,..//Матрица индексов 1 (или список матриц индексов)
                                    indexMatrix2,..//Матрица индексов 2
                                    grid..//Необходимость сеточного размножения индексов
                                    )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 4 then
        error('The function ConcatNamesWithIndexes takes 4, 5 or 6 arguments');
    end
    select nArg
    case 4 then
        if type(indexMatrix1) == 15 then
            indexMatrix = ConcatIndexes(indexMatrix1);
        else
            indexMatrix = indexMatrix1;
        end
    case 5 then
        if (type(indexMatrix1) == 15) && (type(indexMatrix2) ~= 4) then
            error("The argument grid of function ConcatNamesWithIndexes must be boolean");
        end
        indexMatrix = ConcatIndexes(indexMatrix1,indexMatrix2);
    else
        if type(grid) ~= 4 then
            error("The argument grid of function ConcatNamesWithIndexes must be boolean");
        end
        indexMatrix = ConcatIndexes(indexMatrix1,indexMatrix2,grid);
    end
    
    //Проверяем корректность аргументов
    if (type(beginPartName) ~= 10) || (size(beginPartName,'*') > 1) then
        error('The argument beginPartName of function ConcatNamesWithIndexes must be scalar string');
    end
    if (type(endPartName) ~= 10) || (size(endPartName,'*') > 1) then
        error('The argument endPartName of function ConcatNamesWithIndexes must be scalar string');
    end
    if (type(indexSepName) ~= 10) || (size(indexSepName,'*') > 1) then
        error('The argument indexSepName of function ConcatNamesWithIndexes must be scalar string');
    end
    
    //Переводим индексы в строку
    sindexMatrix = string(indexMatrix);
    
    //Конкатенуем индексированные имена
    indexNames = beginPartName + strcat(sindexMatrix,indexSepName,'c') + endPartName;
endfunction
